package tese.intervalos.operacoes;

import tese.intervalos.base.Intervalo;
import tese.intervalos.base.Number;
import tese.intervalos.Constantes;
import tese.intervalos.excecoes.ExcecaoIntervaloVazio;

/**
 * <p>Title: </p>
 * <p>Description: </p>
 * <p>Copyright: Copyright (c) 2005</p>
 * <p>Company: </p>
 * @author unascribed
 * @version 1.0
 */

public class Interseccao extends OperacaoBinaria {

  public Interseccao(Intervalo op1, Intervalo op2) {
    super(op1,op2);
  }

  /**
   * Executa a operacao
   * @return
   */
  public Intervalo executarOperacao() throws ExcecaoIntervaloVazio{

    if (!(Number.comparar(Number.min(operador1.getLimiteSuperior(), operador2.getLimiteSuperior()),
          Number.max(operador1.getLimiteInferior(), operador2.getLimiteInferior())) < 0)) {

      if (Number.comparar(operador1.getLimiteInferior(),
                          operador2.getLimiteInferior()) >= 0){
        this.limiteInferior = operador1.getLimiteInferior();
      } else {
        this.limiteInferior = operador2.getLimiteInferior();
      }

      if (Number.comparar(operador1.getLimiteSuperior(),
                          operador2.getLimiteSuperior()) <= 0) {
        this.limiteSuperior = operador1.getLimiteSuperior();
      } else {
        this.limiteSuperior = operador2.getLimiteSuperior();
      }
    } else {
      throw new ExcecaoIntervaloVazio(this);
    }
    return this;
  }

  public static void main (String args[]) {
    try {
    System.out.print(new Interseccao(new Intervalo(new Number("-9"), new Number("14"))
                                   , new Intervalo(new Number("-30"), new Number("6"))));
    } catch (Exception e) {
      e.printStackTrace();
    }

  }
}