package tese.intervalos.operacoes;

import tese.intervalos.base.Intervalo;
import tese.intervalos.base.Number;
/**
 * <p>Title: </p>
 * <p>Description: </p>
 * <p>Copyright: Copyright (c) 2005</p>
 * <p>Company: </p>
 * @author unascribed
 * @version 1.0
 */

public class InversoAditivo extends OperacaoUnaria{

  public InversoAditivo(Intervalo op1) {
    super(op1);
  }

  public Intervalo executarOperacao() {
    Number n = this.intervalo.getLimiteInferior().clonar();
    n.setSinal(-n.getSinal());
    Number m = this.intervalo.getLimiteSuperior().clonar();
    m.setSinal(-m.getSinal());

    this.setLimiteInferior(m);
    this.setLimiteSuperior(n);
    return this;
  }

  public static void main(String args[]){
    Intervalo i = new Intervalo("-6.123E12","8123E-12");
    InversoAditivo inv = new InversoAditivo(i);
    System.out.println(inv);
  }

}