package tese.intervalos.operacoes;

import tese.intervalos.base.Intervalo;
import tese.intervalos.base.Number;

/**
 * <p>Title: </p>
 * <p>Description: </p>
 * <p>Copyright: Copyright (c) 2005</p>
 * <p>Company: </p>
 * @author unascribed
 * @version 1.0
 */

public class Uniao extends OperacaoBinaria {

  public Uniao(Intervalo op1, Intervalo op2) {
    super(op1,op2);
  }

  /**
   *
   * @return
   */
  public Intervalo executarOperacao() {
    //se esta operacao for executado sem levantar excecao a uniao pode ser feita
    Intervalo i = new Interseccao(operador1, operador2).executarOperacao();

    this.limiteInferior = Number.min(operador1.getLimiteInferior(), operador2.getLimiteInferior());
    this.limiteSuperior = Number.max(operador1.getLimiteSuperior(), operador2.getLimiteSuperior());

    return this;
  }

  public static void main (String args[]) {
    System.out.print(new Uniao(
                               new Intervalo(new Number("-9"),  new Number("-8")),
                               new Intervalo(new Number("-7"), new Number("9"))));

  }
}