package tese.intervalos.operacoes;

import tese.intervalos.base.Intervalo;
import tese.intervalos.base.Number;
import tese.intervalos.excecoes.ExcecaoDivisaoPorZero;

/**
 * <p>Title: </p>
 * <p>Description: </p>
 * <p>Copyright: Copyright (c) 2005</p>
 * <p>Company: </p>
 * @author unascribed
 * @version 1.0
 */

public class InversoMultiplicativo extends OperacaoUnaria {

  public InversoMultiplicativo(Intervalo op1) {
    super(op1);
  }

  public Intervalo executarOperacao() throws ExcecaoDivisaoPorZero{
    Number zero = new Number();

    if ((Number.comparar(zero, this.intervalo.getLimiteSuperior()) <= 0) &&
        (Number.comparar(zero, this.intervalo.getLimiteInferior()) >= 0)) {
      throw new ExcecaoDivisaoPorZero(this);
    } else {
      Number m = this.intervalo.getLimiteSuperior().clonar();
      Number n = this.intervalo.getLimiteInferior().clonar();
      this.setLimiteSuperior(Number.inversoMultiplicativo(n));
      this.setLimiteInferior(Number.inversoMultiplicativo(m));
    }
    return this;
  }

  public static void main(String args[]) {
    System.out.println(new InversoMultiplicativo(new Intervalo("656/-12E123","1234/-48E456")));
  }
}