package tese.intervalos.operacoes;

import tese.intervalos.base.Intervalo;
import tese.intervalos.base.Number;

/**
 * <p>Title: </p>
 * <p>Description: </p>
 * <p>Copyright: Copyright (c) 2005</p>
 * <p>Company: </p>
 * @author unascribed
 * @version 1.0
 */

public class Multiplicacao extends OperacaoBinaria {

  public Multiplicacao(Intervalo op1, Intervalo op2) {
    super(op1, op2);
  }
  public Intervalo executarOperacao() {
    Number [] extremos = calcularExtremos();
    this.setLimiteInferior(extremos[0]);
    this.setLimiteSuperior(extremos [1]);
    return this;
  }

  private Number [] calcularExtremos(){
    Number[] produtos = new Number [4];

    produtos[0] = Number.multiplicar(operador1.getLimiteInferior(), operador2.getLimiteInferior());
    produtos[1] = Number.multiplicar(operador1.getLimiteSuperior(), operador2.getLimiteInferior());
    produtos[2] = Number.multiplicar(operador1.getLimiteInferior(), operador2.getLimiteSuperior());
    produtos[3] = Number.multiplicar(operador1.getLimiteSuperior(), operador2.getLimiteSuperior());

    Number max = produtos[0];
    Number min = produtos[0];

    for (int i = 1; i < produtos.length; i ++) {
      if (Number.comparar(produtos[i], max) > 0) {
        max = produtos[i];
      } else if (Number.comparar(produtos[i],min) < 0) {
        min = produtos[i];
      }
    }
    return new Number [] {min, max};
  }

  public static void main(String args[]){
    System.out.println(new Multiplicacao(new Intervalo("1","2"), new Intervalo("-1","14/7")));
  }
}